#!/usr/bin/perl -w
# Do pre-commit stuff.
# $Fuller: myprograms/cvsmail/precommit.pl,v 1.6 2002/11/24 08:48:59 fullermd Exp $

use lib $ENV{CVSROOT};
use CVSROOT::cvsmail;

# Do pre-commit stuff
$directory = $ARGV[0];
shift @ARGV;

# Collapse down RCS ID strings if necessary
if($cvsmail::UNEXPAND_ID==1)
{
	foreach $file (@ARGV)
	{
		# Don't try known-binary files.
		# This saves time, and Perl trying to be smart when it has
		# Unicode support.
		if($file =~ /$cvsmail::NO_UNEXPAND$/)
		{ next; }

		# Don't try files that aren't there ("cvs rm"'d, for instance)
		if(!(-f $file))
		{ next; }

		open OLD, "< $file";
		open NEW, "> $file.tmp";
		while(<OLD>)
		{
			$_ =~ s/\$($cvsmail::IDHEADER).*?\$/\$$1\$/;
			print NEW $_;
		}
		close OLD;
		close NEW;
		system($cvsmail::P_MV, "$file.tmp", "$file");
	}
}

# Make sure our dir is there
mkdir $cvsmail::TMPDIR, 01777 || die "Can't make tempdir $cvsmail::TMPDIR!";
chmod 01777, $cvsmail::TMPDIR;

# Record this dir.  The final script is going to use this ugly hack to
# allow multi-directory commits to work nicely.
umask(077);
open LASTF, "> $cvsmail::FILE_LASTDIR";
print LASTF "$directory\n";
close LASTF;

# Fin
exit(0);
